首页 > 代码库 > Watch The Movie
Watch The Movie
Watch The Movie
Time Limit : 3000/1000ms (Java/Other) Memory Limit : 65535/65535K (Java/Other)
Total Submission(s) : 10 Accepted Submission(s) : 4
Font: Times New Roman | Verdana | Georgia
Font Size: ← →
Problem Description
New semester is coming, and DuoDuo has to go to school tomorrow. She decides to have fun tonight and will be very busy after tonight. She like watch cartoon very much. So she wants her uncle to buy some movies and watch with her tonight. Her grandfather gave them L minutes to watch the cartoon. After that they have to go to sleep.
DuoDuo list N piece of movies from 1 to N. All of them are her favorite, and she wants her uncle buy for her. She give a value Vi (Vi > 0) of the N piece of movies. The higher value a movie gets shows that DuoDuo likes it more. Each movie has a time Ti to play over. If a movie DuoDuo choice to watch she won’t stop until it goes to end.
But there is a strange problem, the shop just sell M piece of movies (not less or more then), It is difficult for her uncle to make the decision. How to select M piece of movies from N piece of DVDs that DuoDuo want to get the highest value and the time they cost not more then L.
How clever you are! Please help DuoDuo’s uncle.
DuoDuo list N piece of movies from 1 to N. All of them are her favorite, and she wants her uncle buy for her. She give a value Vi (Vi > 0) of the N piece of movies. The higher value a movie gets shows that DuoDuo likes it more. Each movie has a time Ti to play over. If a movie DuoDuo choice to watch she won’t stop until it goes to end.
But there is a strange problem, the shop just sell M piece of movies (not less or more then), It is difficult for her uncle to make the decision. How to select M piece of movies from N piece of DVDs that DuoDuo want to get the highest value and the time they cost not more then L.
How clever you are! Please help DuoDuo’s uncle.
Input
The first line of the input file contains a single integer t (1 ≤ t ≤ 10), the number of test cases, followed by input data for each test case:
The first line is: N(N <= 100),M(M<=N),L(L <= 1000)
N: the number of DVD that DuoDuo want buy.
M: the number of DVD that the shop can sale.
L: the longest time that her grandfather allowed to watch.
The second line to N+1 line, each line contain two numbers. The first number is the time of the ith DVD, and the second number is the value of ith DVD that DuoDuo rated.
The first line is: N(N <= 100),M(M<=N),L(L <= 1000)
N: the number of DVD that DuoDuo want buy.
M: the number of DVD that the shop can sale.
L: the longest time that her grandfather allowed to watch.
The second line to N+1 line, each line contain two numbers. The first number is the time of the ith DVD, and the second number is the value of ith DVD that DuoDuo rated.
Output
Contain one number. (It is less then 2^31.)
The total value that DuoDuo can get tonight.
If DuoDuo can’t watch all of the movies that her uncle had bought for her, please output 0.
The total value that DuoDuo can get tonight.
If DuoDuo can’t watch all of the movies that her uncle had bought for her, please output 0.
Sample Input
1 3 2 10 11 100 1 2 9 1
Sample Output
3
Source
2010 ACM-ICPC Multi-University Training Contest(6)——Host by BIT
//题意是说多多想看卡通,但是爷爷只给了L分钟,多多的购物清单有N种物品需要叔叔帮他买,每种物品多多都会给相应的价值和代价但是超市只卖M种物品,问能得到的最大价值是多少??
显然是多重背包问题,设dp[i][j]表示背包载重为j时,选取物品i个的最优解。状态转移方程:dp[i][j]=max(dp[i-1][j-w[i]]]+v[i];
关于初始化问题:
对于必须装满的背包是需要将数组初始化的,在这里要注意的是当求最大值时需要初始化成-maxlongint而求最小值时需要初始化成maxlongint,然后再将必须装满的某一维或多维体积所对应的体积为0的数组部分初始化成0。
#include<cstdio> #include<cstring> #include<algorithm> using namespace std; int n, m, l; int D[101][2]; int dp[101][1001]; int main() { while(scanf("%d%d%d",&n,&m,&l) != EOF) { int i, j, k; for(i = 1; i <= n; i++) scanf("%d%d",&D[i][0],&D[i][1]); for(i = 0; i <= m; i++) for(j = 0; j <= l; j++) dp[i][j] = -99999999; //注意初始化为负无穷大,求最大值 for(j = 0; j <= l; j++) dp[0][j] = 0;//然后再将必须装满的某一维或多维体积所对应的体积为0的数组部分初始化成0 for(i = 1; i <= n; i++) for(j = m; j >= 1; j--) //注意必须从m->1,否则错误! for(k = l; k >= D[i][0]; k--)//为了确保推出来的dp[m][l]是最大值所以m跟l必须逆序。 dp[j][k] = max(dp[j-1][k-D[i][0]] + D[i][1], dp[j][k]); if(dp[m][l] < 0) dp[m][l] = 0; printf("%d\n",dp[m][l]); } return 0; }
#include<stdio.h> #include<iostream> #include<string.h> using namespace std; int main() { int n,m,l,i,j,k; int c[101]; int w[101]; int dp[1001][101]; while(~scanf("%d%d%d",&n,&m,&l)) { for(i=1;i<=n;i++) { scanf("%d%d",&c[i],&w[i]); } memset(dp,-1,sizeof(dp)); dp[0][0]=0; for(i=1;i<=n;i++) { for(j=l;j>=c[i];j--) { for(k=1;k<=i;k++)//k要小于i因为m<n { if(dp[j-c[i]][k-1]!=-1)dp[j][k]=max(dp[j][k],dp[j-c[i]][k-1]+w[i]); } } } int maxx; maxx=0; for(i=0;i<=l;i++)maxx=max(maxx,dp[i][m]); cout<<maxx<<endl; } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。